#!/usr/bin/perl
# openports.pl by Sven 'Darkman' Michels <darkman@gmx.net> (c) 2000
# This little script should run as a cronjob every 5 (?) minutes to check
# if there are new ports listening on the machine.

use strict;

my (@tcpp, @tcp, @args);
my (@tmpargs, @user);
my ($tcpports, $line, $erg);
my ($spid, $user);
my ($check, $sumold, $sumnew);
my ($oldfile, $old);
my (@sumold, @sumnew);
my ($diffs, @diffs);

sub info {
print "This is a small programm that will check if a new listening port is open.\n";
print "There is no warranty for 100% of security!\n\n";
}

$tcpports = `netstat -ltnp 2>/dev/null`;
@tcpp = split(/\n/, $tcpports);

foreach $line (@tcpp) {
	$line =~ s/ [ ]*/ /g;
	@args = split (/ /, $line);
	if ($args[5] eq "LISTEN") { 
		if ($args[4] eq "0.0.0.0:*") {
		@tmpargs = split(/:/, $args[3]);
			if ($tmpargs[0] eq "0.0.0.0") { $tmpargs[0] = "Listening on every IP/device with port"; }
			else { $tmpargs[0] = "Listening on IP $tmpargs[0] with port"; }
			if ($args[6] eq "-") { $args[6] = "an unknown PID!!!"; }
			else { 
				$spid = $args[6];
				$spid =~ s/\/.*//;
				$user = `ps uh $spid`;
				@user = split(/ /, $user);
				$user = $user[0];
				$args[6] =~ s/\//, process /; $args[6] = "PID $args[6], user $user";
			}
			$erg = "$tmpargs[0] $tmpargs[1] opened by $args[6]";
			push(@tcp, $erg); 
		}
	}
}

$oldfile = system("test -f /var/lib/openports/data/outopold.log");

if ($oldfile ne "0") { 
			$check = "no";
}

open(LOG, ">>/var/lib/openports/data/outop.log") or die "Error opening logfile: $!";
foreach $line (@tcp) { print LOG "$line\n"; }
close (LOG);

if ($check ne "no") {
$sumold = `md5sum /var/lib/openports/data/outopold.log`;
$sumnew = `md5sum /var/lib/openports/data/outop.log`;
@sumold = split(/ /, $sumold);
@sumnew = split(/ /, $sumnew);
$sumold = $sumold[0];
$sumnew = $sumnew[0];
}

if ($check eq "no" or $sumold ne $sumnew) {
info;
if ($check eq "no") {
	print "warning: the old log does not exist! This means that possibly somebody deleted it.\n";
	print "You can safely ignore this message if this is the first run of openports\n\n";
}
if ($sumold ne $sumnew) { print "ATTENTION! Some new listening ports are detected.\n"; $old = "yes"; }
if ($old eq "yes") {
	$diffs = `diff -uw /var/lib/openports/data/outopold.log /var/lib/openports/data/outop.log |egrep -v '^+++ |^---' | sed 's/^[+-]/& /'`; 
	@diffs = split(/\n/, $diffs);
	foreach $line (@diffs) {
		if (!($line =~ /\@\@/)) { print "$line\n"; }
	}
} else {
print "This is the actually list of listening ports:\n";
open(LOG, "</var/lib/openports/data/outop.log") or die "Error opening logfile: $!";
while (<LOG>) { print $_; }
close(LOG);
}
}

rename("/var/lib/openports/data/outop.log", "/var/lib/openports/data/outopold.log") or die "Error renaming logfile: $!";

exit 0;
